﻿


Public Class FormFind

    Dim FindOption As FindData = New FindData()
    Dim Results As Collection = New Collection
    Private Sub FormFind_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tbGroupCode.Text = 0
        cbFilterGroupCode.Checked = False
        tbGroupCode.Enabled = False
    End Sub

    Private Sub butHide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butHide.Click
        Hide()
    End Sub

    Private Sub FormFind_Activated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        TopMost = True


    End Sub

    Private Sub butFindFromTop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butFindFromTop.Click
        '      ResultCollection.Clear()

        tbStatus.Text = "探しています。"
        tbStatus.Update()
        lbFound.Items.Clear()
        Results.Clear()
        FindOption.word = tbFindText.Text
        FindOption.bPartialMatch = cbPartial.Checked
        FindOption.bNoCase = cbNoCase.Checked
        If (cbFilterGroupCode.Enabled = True) Then
            FindOption.GroupCode = CInt(tbGroupCode.Text)
        Else
            FindOption.GroupCode = -1
        End If
        tbStatus.Text = Form1.FindTextFromTop(FindOption, Results)
        Dim result As FindResultData
        If (Results.Count > 0) Then
            For i As Integer = 1 To Results.Count
                result = Results.Item(i)
                lbFound.Items.Add(result.pos)

            Next
            ExpandFoundNode(Results.Item(1))
        End If



    End Sub
    Private Sub butFindTreeNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butFindTreeNode.Click
        tbStatus.Text = "探しています。"
        tbStatus.Update()
        lbFound.Items.Clear()
        Results.Clear()
        FindOption.word = tbFindText.Text
        FindOption.bPartialMatch = cbPartial.Checked
        FindOption.bNoCase = cbNoCase.Checked
        If (cbFilterGroupCode.Enabled = True) Then
            FindOption.GroupCode = CInt(tbGroupCode.Text)
        Else
            FindOption.GroupCode = -1
        End If
        tbStatus.Text = Form1.FindTextInSelectedNode(FindOption, Results)
        Dim result As FindResultData
        If (Results.Count > 0) Then
            For i As Integer = 1 To Results.Count
                result = Results.Item(i)
                lbFound.Items.Add(result.pos)

            Next
            ExpandFoundNode(Results.Item(1))
        End If

    End Sub

    Sub ExpandFoundNode(ByVal result As FindResultData)
        Dim found As TreeNode = result.node
        found.Expand()
        found.EnsureVisible()
        Form1.tvSections.SelectedNode = found
        Form1.tvSections.Update()
        If (result.index >= 0) Then
            Form1.ListView1.Items(result.index).EnsureVisible()
            Form1.ListView1.Items(result.index).Selected = True
            Form1.ListView1.Update()
        End If
        Dim data As TreeNodeData = found.Tag
        Form1.Activate()
        Form1.tvSections.Select()
        If (result.node.Name = "ndHeader") Then
            Form1.ListView1.Select()
        End If
    End Sub

    Private Sub lbFound_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbFound.SelectedIndexChanged
        Dim index As Integer = lbFound.SelectedIndex
        ExpandFoundNode(Results.Item(index + 1))
    End Sub





    Private Sub FormFind_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        e.Cancel = True
        Hide()
    End Sub

    Private Sub cbFilterGroupCode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbFilterGroupCode.CheckedChanged
        If (cbFilterGroupCode.Checked = True) Then
            tbGroupCode.Enabled = True
        Else
            tbGroupCode.Enabled = False
        End If
    End Sub

End Class



''' <summary>
''' ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''' </summary>
''' <remarks></remarks>
Public Class FindData
    Public bPartialMatch As Boolean
    Public bNoCase As Boolean
    Public word As String
    'Public bFindElement As Boolean
    Public GroupCode As String
    Public Value As String
    Sub New()
        'bFindElement = False
        GroupCode = -1
    End Sub
End Class
''' <summary>
''' ''''''''''''''''''''''''''''''''''''''''''''
''' </summary>
''' <remarks></remarks>
Public Class FindResultData
    Public pos As String
    Public node As TreeNode
    Public index As Integer
    Public GroupCode As Integer
    Public Value As String
    Sub New(ByVal path As String, ByVal foundNode As TreeNode)
        pos = path
        node = foundNode
        index = -1
    End Sub
End Class